#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QPushButton>
#include <QGraphicsProxyWidget>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow),	m_pScene(new QGraphicsScene)
{
    ui->setupUi(this);

    PopulateScene();
    ui->graphicsView->setScene(m_pScene);
    ui->graphicsView->scale(2.0, 2.0);
}

MainWindow::~MainWindow()
{
    delete m_pScene;
    delete ui;
}

#define WIDTH 200
#define HEIGHT 100
void MainWindow::PopulateScene()
{
    //Important condition - widget should be before all other items (Z-order)
    auto pButton = new QPushButton("Button");
    auto pButtonProxy = m_pScene->addWidget(pButton);
    pButtonProxy->setPos(WIDTH * 10, HEIGHT * 10);

    for (size_t i = 0; i < 20; i++)
    {
        for (size_t j = 0; j < 20; j++)
        {
            // Text is big enough to cover the entire rectangle
            auto pRect = m_pScene->addRect(QRectF(0, 0, WIDTH, HEIGHT));
            auto pText = m_pScene->addSimpleText("LongText");
            auto qFont = pText->font();
            qFont.setPointSize(40);
            pText->setFont(qFont);
            pText->setParentItem(pRect);

            pRect->setPos(j * WIDTH, i * HEIGHT);
        }
    }
}
